/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef common_h
#define common_h

#include "nil-dither.h"

#define C64_PALETTE_OPTIONS \
  {"colodore",'C',NULL,"use the Colodore palette"},\
  {"godot",'G',NULL,"use the GoDot palette"},\
  {"pepto",'P',NULL,"use the Pepto palette"},

#define C64_PALETTE_PARSE \
  case 'C': opt_palette = NIL_C64_COLODORE; return 0;\
  case 'G': opt_palette = NIL_C64_GODOT; return 0;\
  case 'P': opt_palette = NIL_C64_PEPTO; return 0;

#define DITHER_OPTIONS \
  {"no-dither",'n',NULL,"use no dithering"},\
  {"ordered4x4",'4',NULL,"use ordered 4x4 dithering"},\
  {"ordered8x8",'8',NULL,"use ordered 8x8 dithering"},\
  {"floyd-steinberg",'f',NULL,"use floyd-steinberg dithering"},\
  {"jarvis-judice-ninke",'j',NULL,"use jarvis-judice-ninke dithering (the default)"},\
  {"stucki",'s',NULL,"use stucki dithering"},

#define DITHER_PARSE \
  case 'n': opt_dither = NIL_DITHER_NONE; return 0;\
  case '4': opt_dither = NIL_DITHER_ORD4; return 0;\
  case '8': opt_dither = NIL_DITHER_ORD8; return 0;\
  case 'f': opt_dither = NIL_DITHER_FS; return 0; \
  case 'j': opt_dither = NIL_DITHER_JJN; return 0; \
  case 's': opt_dither = NIL_DITHER_STUCKI; return 0;

void dither(nile_t*,nil_dither_type_t,int xoffs,int yoffs,int channel_depth);
double compare_planar(const nile_t*,const nile_t*);

#endif /* common_h */
