/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef convert_h
#define convert_h

#include <stdio.h>

typedef struct{
    const char *name;
    int val;
    const char *arg;
    const char *description;
}convert_option_t;

typedef int(*convert_option_func_t)(int opt, const char *arg);

typedef struct{
    const char *progname;
    const char *inext;
    const char *outext;
    const char *outname;
    const convert_option_t *opts;
    FILE *in;
    FILE *out;
}convert_t;

void convert_init(convert_t*, int argc, char **argv, const char *inext, const char *outext, const char *outname, const convert_option_t*, convert_option_func_t);
void convert_done(convert_t*);
void convert_usage(convert_t*);

#endif /* convert_h */
