/*
 * Copyright (C) 2020  Magnus Bergman <magnus@snisurset.net>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#include "ni-tiled.h"


static void _init(nile_t *dst, const nile_t *src, int width, int height){
    dst->width = width;
    dst->height = height;
    dst->format = src->format;
    dst->bpc = src->bpc;
    dst->colors = src->colors;
    //dst->palette = src->palette;
}


int ni_excerpt_planar(nile_t *dst,const nile_t *src,int x,int y,int width,int height){
    int stride = nile_get_planar_stride(src);
    _init(dst,src,width,height);
    nile_drop_planar(dst);
    dst->planar = src->planar + x*src->bpc + y*stride;
    dst->planar_stride = stride;
    return 0;
}


int ni_excerpt_indexed(nile_t *dst,const nile_t *src,int x,int y,int width,int height){
    int stride = nile_get_indexed_stride(src);
    _init(dst,src,width,height);
    nile_drop_indexed(dst);
    dst->indexed = src->indexed + x + y*stride;
    dst->indexed_stride = stride;
    return 0;
}
