/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef nil_quant_h
#define nil_quant_h

#include "hashmap.h"
#include "nile.h"

typedef struct{
    int channel_depth;
    hashmap_t color_map;
    int total_pixels;
}nil_quant_set_t;

nil_quant_set_t *nil_quant_set_init(nil_quant_set_t*,int channel_depth);
void nil_quant_set_done(nil_quant_set_t*);
#define nil_quant_set_colors(s) hashmap_size(&(s)->color_map)

void nil_quant_set_add(nil_quant_set_t*, const uint8_t *color, int count, const nile_t*);
void nil_quant_set_add_indexed_pixels(nil_quant_set_t*, const nile_t*);
void nil_quant_set_add_planar_pixels(nil_quant_set_t*, const nile_t*);
void nil_quant_set_add_nearest(nil_quant_set_t*, const uint8_t *color, int count, const nile_t*);
void nil_quant_set_add_nearest_indexed_pixels(nil_quant_set_t*, const nile_t*);
void nil_quant_set_add_nearest_planar_pixels(nil_quant_set_t*, const nile_t*);
void nil_quant_set_reduce_mix(nil_quant_set_t*, int colors, const nile_t*);
void nil_quant_set_reduce_simple(nil_quant_set_t*, int colors, const nile_t*);
void nil_quant_set_get_palette(nil_quant_set_t*, nile_t*);

void nil_quant(nile_t*, int colors, int channel_depth);

#endif /* nil_quant_h */
