/*
 * Copyright (C) 2020  Magnus Bergman <magnus@snisurset.net>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#include <float.h>                      /* DBL_MAX */

#include "nil-remap.h"


void nil_remap_create_table(uint8_t *table, nile_t *dst, nile_t *src){
    int i;
    for(i=0;i<src->colors;++i)
        table[i] = nile_best_color_index(dst->palette, dst->colors, dst->bpc, dst->format, src->palette + i*src->bpc, src->format);
}


void nil_remap_apply_table(uint8_t *table, nile_t *ni){
    uint8_t *p = ni->indexed;
    int skip = nile_get_indexed_skip(ni);
    int y = ni->height;
    while(y-->0){
        int x = ni->width;
        while(x-->0){
            *p = table[*p];
            ++p;
        }
        p += skip;
    }
}
