/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef pool_h
#define pool_h

#include <stddef.h>                     /* size_t */

typedef struct{
    size_t max;
    char *mem;
    const void *end;
    size_t top;
    size_t count;
    void **freelist;
    int freelist_size;
}pool_block_t;

typedef struct{
    size_t itemsize;
    pool_block_t block[32];
    int top;
    int current;
}pool_t;

pool_t *pool_init(pool_t*,size_t itemsize, size_t minsize);
void pool_done(pool_t*);

void *pool_lease(pool_t*);
void pool_return(pool_t*,void*);

#endif /* pool_h */
